/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ID = 258,
     OP = 259,
     ADD = 260,
     SUBTRACT = 261,
     TIMES = 262,
     DIVIDE = 263,
     MOD = 264,
     EXPONENT = 265,
     DOTS = 266,
     COLONS = 267,
     DASHES = 268,
     INCR = 269,
     LONGDASH = 270,
     CONTROLS = 271,
     TENSION = 272,
     ATLEAST = 273,
     CURL = 274,
     CYCLE = 275,
     COR = 276,
     CAND = 277,
     EQ = 278,
     NEQ = 279,
     LT = 280,
     LE = 281,
     GT = 282,
     GE = 283,
     CARETS = 284,
     AMPERSAND = 285,
     LOGNOT = 286,
     STRING = 287,
     LOOSE = 288,
     ASSIGN = 289,
     DIRTAG = 290,
     JOIN_PREC = 291,
     AND = 292,
     ELLIPSIS = 293,
     IMPORT = 294,
     STRUCT = 295,
     TYPEDEF = 296,
     NEW = 297,
     IF = 298,
     ELSE = 299,
     WHILE = 300,
     DO = 301,
     FOR = 302,
     BREAK = 303,
     CONTINUE = 304,
     RETURN_ = 305,
     STATIC = 306,
     PUBLIC_TOK = 307,
     PRIVATE_TOK = 308,
     THIS = 309,
     EXPLICIT = 310,
     LIT = 311,
     PERM = 312,
     MODIFIER = 313,
     UNARY = 314
   };
#endif
#define ID 258
#define OP 259
#define ADD 260
#define SUBTRACT 261
#define TIMES 262
#define DIVIDE 263
#define MOD 264
#define EXPONENT 265
#define DOTS 266
#define COLONS 267
#define DASHES 268
#define INCR 269
#define LONGDASH 270
#define CONTROLS 271
#define TENSION 272
#define ATLEAST 273
#define CURL 274
#define CYCLE 275
#define COR 276
#define CAND 277
#define EQ 278
#define NEQ 279
#define LT 280
#define LE 281
#define GT 282
#define GE 283
#define CARETS 284
#define AMPERSAND 285
#define LOGNOT 286
#define STRING 287
#define LOOSE 288
#define ASSIGN 289
#define DIRTAG 290
#define JOIN_PREC 291
#define AND 292
#define ELLIPSIS 293
#define IMPORT 294
#define STRUCT 295
#define TYPEDEF 296
#define NEW 297
#define IF 298
#define ELSE 299
#define WHILE 300
#define DO 301
#define FOR 302
#define BREAK 303
#define CONTINUE 304
#define RETURN_ 305
#define STATIC 306
#define PUBLIC_TOK 307
#define PRIVATE_TOK 308
#define THIS 309
#define EXPLICIT 310
#define LIT 311
#define PERM 312
#define MODIFIER 313
#define UNARY 314




/* Copy the first part of user declarations.  */
#line 1 "camp.y"

/*****
 * camp.y
 * Andy Hammerlindl 08/12/2002
 *
 * The grammar of the camp language.
 *****/

#include "errormsg.h"
#include "exp.h"
#include "newexp.h"
#include "dec.h"
#include "fundec.h"
#include "stm.h"
#include "modifier.h"

// Avoid error messages with unpatched bison-1.875:
#ifndef __attribute__
#define __attribute__(x)
#endif

// Used when a position needs to be determined and no token is
// available.  Defined in camp.l.
position lexerPos();

int yylex(void); /* function prototype */

void yyerror(const char *s)
{
  em->error(lexerPos());
  *em << s;
  em->sync();
}

namespace absyntax { file *root; }

using namespace absyntax;
using sym::symbol;


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 41 "camp.y"
typedef union YYSTYPE {
  position pos;
  //sym::symbol *sym;
  struct {
    position pos;
    sym::symbol *sym;
  } ps;
  absyntax::name *n;
  absyntax::varinit *vi;
  absyntax::arrayinit *ai;
  absyntax::exp *e;
  absyntax::specExp *se;
  absyntax::joinExp *j;
  absyntax::explist *elist;
  absyntax::argument arg;
  absyntax::arglist *alist;
  absyntax::dimensions *dim;
  absyntax::ty  *t;
  absyntax::decid *di;
  absyntax::decidlist *dil;
  absyntax::decidstart *dis;
  absyntax::runnable *run;
  struct {
    position pos;
    trans::permission val;
  } perm;
  struct {
    position pos;
    trans::modifier val;
  } mod;
  absyntax::modifierList *ml;
  //absyntax::program *prog;
  absyntax::vardec *vd;
  //absyntax::vardecs *vds;
  absyntax::dec *d;
  absyntax::stm *s;
  absyntax::blockStm *bs;
  absyntax::stmExpList *sel;
  //absyntax::funheader *fh;
  absyntax::formal *fl;
  absyntax::formals *fls;
  absyntax::file *fil;
} YYSTYPE;
/* Line 190 of yacc.c.  */
#line 278 "camp.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 213 of yacc.c.  */
#line 290 "camp.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2033

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  77
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  42
/* YYNRULES -- Number of rules. */
#define YYNRULES  175
/* YYNRULES -- Number of states. */
#define YYNSTATES  336

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   314

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    35,     2,     2,
      48,    49,    33,    30,    51,    32,    50,    34,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    42,    54,
       2,     2,     2,    40,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    52,     2,    53,    36,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    45,     2,    47,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    31,    37,    38,    39,    41,
      43,    44,    46,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     5,     6,     9,    10,    13,    15,    19,
      23,    25,    27,    30,    33,    35,    37,    40,    43,    45,
      47,    49,    53,    57,    60,    63,    65,    68,    70,    73,
      77,    81,    86,    88,    92,    94,    98,   100,   103,   107,
     112,   114,   116,   120,   123,   128,   132,   138,   140,   142,
     145,   147,   151,   153,   157,   160,   162,   166,   168,   171,
     176,   179,   183,   189,   195,   202,   209,   213,   216,   220,
     225,   230,   234,   239,   243,   248,   252,   254,   256,   260,
     262,   266,   269,   271,   275,   277,   279,   281,   283,   286,
     291,   297,   300,   303,   306,   310,   314,   318,   322,   326,
     330,   334,   338,   342,   346,   350,   354,   358,   362,   366,
     370,   374,   377,   381,   386,   390,   395,   401,   408,   415,
     423,   429,   433,   439,   447,   461,   465,   469,   472,   475,
     478,   481,   485,   489,   493,   497,   501,   505,   507,   509,
     512,   515,   519,   524,   528,   534,   536,   540,   544,   546,
     548,   551,   556,   560,   566,   569,   574,   576,   578,   581,
     587,   595,   601,   609,   619,   622,   625,   628,   632,   634,
     635,   637,   639,   640,   642,   644
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      78,     0,    -1,    79,    -1,    -1,    79,    82,    -1,    -1,
      80,    82,    -1,     3,    -1,    81,    50,     3,    -1,    38,
      50,     3,    -1,    84,    -1,   114,    -1,    83,    84,    -1,
      83,    95,    -1,    75,    -1,    74,    -1,    83,    75,    -1,
      83,    74,    -1,    85,    -1,   102,    -1,   103,    -1,    56,
       3,    54,    -1,    56,    38,    54,    -1,    86,    54,    -1,
      87,    91,    -1,    88,    -1,    81,    89,    -1,    81,    -1,
      52,    53,    -1,    89,    52,    53,    -1,    52,   108,    53,
      -1,    90,    52,   108,    53,    -1,    92,    -1,    91,    51,
      92,    -1,    93,    -1,    93,    41,    94,    -1,     3,    -1,
       3,    89,    -1,     3,    48,    49,    -1,     3,    48,    99,
      49,    -1,   108,    -1,    96,    -1,    45,    80,    47,    -1,
      45,    47,    -1,    45,    55,    94,    47,    -1,    45,    97,
      47,    -1,    45,    97,    55,    94,    47,    -1,    51,    -1,
      98,    -1,    98,    51,    -1,    94,    -1,    98,    51,    94,
      -1,   100,    -1,   100,    55,   101,    -1,    55,   101,    -1,
     101,    -1,   100,    51,   101,    -1,    87,    -1,    87,    93,
      -1,    87,    93,    41,    94,    -1,    72,    87,    -1,    72,
      87,    93,    -1,    72,    87,    93,    41,    94,    -1,    87,
       3,    48,    49,    95,    -1,    87,     3,    48,    99,    49,
      95,    -1,    87,     4,    48,    99,    49,    95,    -1,    57,
       3,    95,    -1,    58,    85,    -1,   104,    50,     3,    -1,
      81,    52,   108,    53,    -1,   104,    52,   108,    53,    -1,
      81,    48,    49,    -1,    81,    48,   106,    49,    -1,   104,
      48,    49,    -1,   104,    48,   106,    49,    -1,    48,   108,
      49,    -1,    71,    -1,   108,    -1,     3,    41,   108,    -1,
     107,    -1,   107,    55,   105,    -1,    55,   105,    -1,   105,
      -1,   107,    51,   105,    -1,    81,    -1,   104,    -1,    73,
      -1,    38,    -1,    73,   108,    -1,    48,    81,    49,   108,
      -1,    48,    81,    89,    49,   108,    -1,    30,   108,    -1,
      32,   108,    -1,    37,   108,    -1,   108,    30,   108,    -1,
     108,    32,   108,    -1,   108,    33,   108,    -1,   108,    34,
     108,    -1,   108,    35,   108,    -1,   108,    36,   108,    -1,
     108,    25,   108,    -1,   108,    26,   108,    -1,   108,    27,
     108,    -1,   108,    28,   108,    -1,   108,    23,   108,    -1,
     108,    24,   108,    -1,   108,    22,   108,    -1,   108,    21,
     108,    -1,   108,    29,   108,    -1,   108,    31,   108,    -1,
     108,    14,   108,    -1,    59,    88,    -1,    59,    88,    90,
      -1,    59,    88,    90,    89,    -1,    59,    88,    89,    -1,
      59,    88,    89,    96,    -1,    59,    88,    48,    49,    95,
      -1,    59,    88,    89,    48,    49,    95,    -1,    59,    88,
      48,    99,    49,    95,    -1,    59,    88,    89,    48,    99,
      49,    95,    -1,   108,    40,   108,    42,   108,    -1,   108,
      41,   108,    -1,    48,   108,    51,   108,    49,    -1,    48,
     108,    51,   108,    51,   108,    49,    -1,    48,   108,    51,
     108,    51,   108,    51,   108,    51,   108,    51,   108,    49,
      -1,   108,   109,   108,    -1,   108,   109,    20,    -1,   108,
     110,    -1,    14,   108,    -1,    13,   108,    -1,   108,    14,
      -1,   108,     5,   108,    -1,   108,     6,   108,    -1,   108,
       7,   108,    -1,   108,     8,   108,    -1,   108,     9,   108,
      -1,   108,    10,   108,    -1,    13,    -1,   111,    -1,   110,
     111,    -1,   111,   110,    -1,   110,   111,   110,    -1,    45,
      19,   108,    47,    -1,    45,   108,    47,    -1,    45,   108,
      51,   108,    47,    -1,    11,    -1,    11,   112,    11,    -1,
      11,   113,    11,    -1,    12,    -1,    15,    -1,    17,   108,
      -1,    17,   108,    46,   108,    -1,    17,    18,   108,    -1,
      17,    18,   108,    46,   108,    -1,    16,   108,    -1,    16,
     108,    46,   108,    -1,    54,    -1,    95,    -1,   115,    54,
      -1,    60,    48,   108,    49,   114,    -1,    60,    48,   108,
      49,   114,    61,   114,    -1,    62,    48,   108,    49,   114,
      -1,    63,   114,    62,    48,   108,    49,    54,    -1,    64,
      48,   116,    54,   108,    54,   117,    49,   114,    -1,    65,
      54,    -1,    66,    54,    -1,    67,    54,    -1,    67,   108,
      54,    -1,   108,    -1,    -1,   118,    -1,    86,    -1,    -1,
     118,    -1,   115,    -1,   118,    51,   115,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   163,   163,   167,   168,   173,   174,   184,   185,   186,
     196,   197,   198,   200,   205,   206,   207,   209,   214,   215,
     216,   217,   218,   222,   226,   230,   235,   239,   245,   246,
     250,   251,   256,   257,   262,   263,   268,   269,   270,   272,
     277,   278,   282,   287,   288,   290,   292,   297,   298,   299,
     303,   305,   310,   311,   313,   317,   318,   323,   324,   325,
     327,   329,   331,   336,   338,   340,   345,   346,   351,   352,
     354,   355,   358,   362,   363,   366,   368,   372,   373,   377,
     378,   380,   384,   385,   398,   399,   400,   401,   403,   407,
     411,   413,   415,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   441,   443,   445,   447,   449,   451,   456,   458,
     463,   465,   467,   469,   471,   473,   475,   479,   485,   487,
     490,   492,   493,   495,   496,   497,   498,   505,   506,   508,
     511,   514,   520,   521,   522,   528,   529,   531,   533,   534,
     538,   540,   543,   546,   552,   553,   558,   559,   560,   561,
     563,   565,   567,   569,   571,   572,   573,   574,   578,   582,
     583,   584,   588,   589,   593,   594
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ID", "OP", "ADD", "SUBTRACT", "TIMES",
  "DIVIDE", "MOD", "EXPONENT", "DOTS", "COLONS", "DASHES", "INCR",
  "LONGDASH", "CONTROLS", "TENSION", "ATLEAST", "CURL", "CYCLE", "COR",
  "CAND", "EQ", "NEQ", "LT", "LE", "GT", "GE", "CARETS", "'+'",
  "AMPERSAND", "'-'", "'*'", "'/'", "'%'", "'^'", "LOGNOT", "STRING",
  "LOOSE", "'?'", "ASSIGN", "':'", "DIRTAG", "JOIN_PREC", "'{'", "AND",
  "'}'", "'('", "')'", "'.'", "','", "'['", "']'", "';'", "ELLIPSIS",
  "IMPORT", "STRUCT", "TYPEDEF", "NEW", "IF", "ELSE", "WHILE", "DO", "FOR",
  "BREAK", "CONTINUE", "RETURN_", "STATIC", "PUBLIC_TOK", "PRIVATE_TOK",
  "THIS", "EXPLICIT", "LIT", "PERM", "MODIFIER", "UNARY", "$accept",
  "file", "fileblock", "bareblock", "name", "runnable", "modifiers", "dec",
  "vardec", "barevardec", "type", "celltype", "dims", "dimexps",
  "decidlist", "decid", "decidstart", "varinit", "block", "arrayinit",
  "basearrayinit", "varinits", "formals", "baseformals", "formal",
  "fundec", "typedec", "value", "argument", "arglist", "basearglist",
  "exp", "join", "dir", "basicjoin", "tension", "controls", "stm",
  "stmexp", "forinit", "forupdate", "stmexplist", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      43,   285,    45,    42,    47,    37,    94,   286,   287,   288,
      63,   289,    58,   290,   291,   123,   292,   125,    40,    41,
      46,    44,    91,    93,    59,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    77,    78,    79,    79,    80,    80,    81,    81,    81,
      82,    82,    82,    82,    83,    83,    83,    83,    84,    84,
      84,    84,    84,    85,    86,    87,    87,    88,    89,    89,
      90,    90,    91,    91,    92,    92,    93,    93,    93,    93,
      94,    94,    95,    96,    96,    96,    96,    97,    97,    97,
      98,    98,    99,    99,    99,   100,   100,   101,   101,   101,
     101,   101,   101,   102,   102,   102,   103,   103,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   105,   105,   106,
     106,   106,   107,   107,   108,   108,   108,   108,   108,   108,
     108,   108,   108,   108,   108,   108,   108,   108,   108,   108,
     108,   108,   108,   108,   108,   108,   108,   108,   108,   108,
     108,   108,   108,   108,   108,   108,   108,   108,   108,   108,
     108,   108,   108,   108,   108,   108,   108,   108,   108,   108,
     108,   108,   108,   108,   108,   108,   108,   109,   109,   109,
     109,   109,   110,   110,   110,   111,   111,   111,   111,   111,
     112,   112,   112,   112,   113,   113,   114,   114,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   115,   116,
     116,   116,   117,   117,   118,   118
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     0,     2,     0,     2,     1,     3,     3,
       1,     1,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     3,     3,     2,     2,     1,     2,     1,     2,     3,
       3,     4,     1,     3,     1,     3,     1,     2,     3,     4,
       1,     1,     3,     2,     4,     3,     5,     1,     1,     2,
       1,     3,     1,     3,     2,     1,     3,     1,     2,     4,
       2,     3,     5,     5,     6,     6,     3,     2,     3,     4,
       4,     3,     4,     3,     4,     3,     1,     1,     3,     1,
       3,     2,     1,     3,     1,     1,     1,     1,     2,     4,
       5,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     4,     3,     4,     5,     6,     6,     7,
       5,     3,     5,     7,    13,     3,     3,     2,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     1,     1,     2,
       2,     3,     4,     3,     5,     1,     3,     3,     1,     1,
       2,     4,     3,     5,     2,     4,     1,     1,     2,     5,
       7,     5,     7,     9,     2,     2,     2,     3,     1,     0,
       1,     1,     0,     1,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       3,     0,     2,     1,     7,     0,     0,     0,     0,     0,
      87,     5,     0,   156,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    76,    86,    15,    14,    84,
       4,     0,    10,    18,     0,     0,    25,   157,    19,    20,
      85,   168,    11,     0,    84,   129,   128,    91,    92,    93,
       0,     0,    84,     0,     0,     0,     0,     0,    27,    67,
       0,    27,   111,     0,     0,     0,   169,   164,   165,   166,
       0,    88,     0,     0,     0,    26,    17,    16,    12,    13,
      23,    36,     0,    24,    32,    34,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   145,   148,   137,   130,   149,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     127,   138,   158,     0,     9,    42,     6,     0,     0,    75,
       0,    21,    22,    66,     0,    36,     0,     0,   114,   112,
       0,     0,     0,   171,   174,     0,   170,   167,     7,    71,
       0,    82,     0,    79,    77,     8,    28,     0,     0,     0,
      37,     0,     0,     0,    73,     0,    68,     0,   131,   132,
     133,   134,   135,   136,     0,     0,     0,     0,   110,   107,
     106,   104,   105,   100,   101,   102,   103,   108,    94,   109,
      95,    96,    97,    98,    99,     0,   121,     0,     0,   126,
     125,   139,   140,    89,     0,     0,     0,     0,     0,     0,
      57,     0,    52,    55,     0,     0,     0,   115,     0,   113,
       0,     0,     0,     0,     0,     0,    81,    72,     0,     0,
      69,    29,    38,     0,     0,    33,    35,    41,    40,    74,
      70,   154,     0,   150,   146,   147,     0,     0,   143,     0,
     141,    90,   122,     0,    38,     0,   116,    54,    60,    58,
       0,     0,     0,    30,    43,    47,     0,    50,     0,    48,
       0,     0,     0,   159,   161,     0,     0,   175,    78,    83,
      80,    63,    39,     0,     0,   152,     0,   120,   142,     0,
       0,    39,    61,     0,   118,    56,    53,     0,    45,     0,
      49,   117,     0,    31,     0,     0,   172,    64,    65,   155,
       0,   151,   144,   123,     0,     0,    59,    44,     0,    51,
     119,   160,   162,     0,   173,   153,     0,    62,    46,     0,
       0,   163,     0,     0,     0,   124
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     1,     2,    51,    44,    30,    31,    32,    33,    34,
     210,    36,    75,   139,    83,    84,    85,   236,    37,   237,
     268,   269,   211,   212,   213,    38,    39,    40,   151,   152,
     153,    41,   119,   120,   121,   176,   177,    42,    43,   145,
     323,   146
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -196
static const short int yypact[] =
{
    -196,    35,   354,  -196,  -196,   667,   667,   667,   667,   667,
     -37,  -196,   667,  -196,    11,    42,    13,    13,    -1,    27,
     419,    44,    67,    81,   539,  -196,   112,  -196,  -196,   222,
    -196,   116,  -196,  -196,    93,   137,  -196,  -196,  -196,  -196,
     -12,  1759,  -196,    97,    -6,   117,   117,   117,   117,  -196,
     149,   289,    30,  1044,   101,   102,   114,   -37,    86,  -196,
     154,   134,   -24,   667,   667,   100,   667,  -196,  -196,  -196,
     748,   117,   485,   184,   548,   136,  -196,  -196,  -196,  -196,
    -196,    16,   141,   144,  -196,   155,   511,   198,   667,   667,
     667,   667,   667,   667,   667,   127,  -196,  -196,   112,  -196,
     667,   667,   667,   667,   667,   667,   667,   667,   667,   667,
     667,   667,   667,   667,   667,   667,   667,   667,   576,   602,
    -196,   157,  -196,   667,  -196,  -196,  -196,   667,   -20,  -196,
     667,  -196,  -196,  -196,   151,    18,    22,   548,   -18,   156,
    1326,  1371,   161,  -196,  -196,   162,   160,  -196,   186,  -196,
     693,  -196,   179,    79,  1759,  -196,  -196,   848,   177,   126,
     136,   125,   154,   639,  -196,   182,  -196,   897,  1759,  1759,
    1759,  1759,  1759,  1759,   667,   630,   223,   225,    20,  1870,
    1896,  1922,  1922,  1948,  1948,  1948,  1948,  1974,   143,  1988,
     143,   117,   117,   117,   117,  1718,  1759,   667,  1091,  -196,
      20,   157,  -196,   117,   667,  1138,   183,   114,   128,    13,
     154,   190,    82,  -196,   946,   457,   191,  -196,   548,   136,
     419,   419,   667,   667,   667,   667,  -196,  -196,   693,   693,
    -196,  -196,   114,   193,   194,  -196,  -196,  -196,  1759,  -196,
    -196,  1592,   667,  1634,  -196,  -196,   667,  1506,  -196,   667,
    -196,   117,  -196,   667,  -196,   200,  -196,  -196,   154,   192,
     114,   128,   128,  -196,  -196,  -196,   639,  -196,   -38,   196,
     114,   202,   995,   195,  -196,  1416,   798,  -196,  1759,  -196,
    -196,  -196,   114,   114,   667,  1676,   667,  1835,  -196,  1549,
    1185,  -196,   211,   639,  -196,  -196,  -196,   206,  -196,   639,
     639,  -196,   114,  -196,   419,   205,   667,  -196,  -196,  1800,
     667,  1800,  -196,  -196,   667,   639,  -196,  -196,   207,  -196,
    -196,  -196,  -196,   213,   160,  1800,  1232,  -196,  -196,   419,
     667,  -196,  1279,   667,  1461,  -196
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -196,  -196,  -196,  -196,     6,   209,  -196,   233,   249,   203,
      10,   254,   -19,  -196,  -196,   104,  -195,  -176,   -25,   135,
    -196,  -196,   -13,  -196,  -188,  -196,  -196,  -196,  -102,   189,
    -196,    -5,  -196,  -110,   158,  -196,  -196,   -15,   -56,  -196,
    -196,   -30
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -28
static const short int yytable[] =
{
      45,    46,    47,    48,    49,    65,    79,    53,    29,   298,
     144,   202,    35,    50,    54,   259,     4,   299,    52,    70,
     257,    71,    58,    61,   136,     4,    60,   215,   137,   204,
     216,   133,   158,   128,   158,     3,    86,    58,    87,   267,
      88,    35,    72,   138,    73,    56,   123,    63,   226,    55,
     109,    57,   111,   112,   113,   114,   115,    29,   140,   141,
      57,    35,   160,   292,   159,   118,   206,   154,   134,   157,
     134,   207,    29,   295,   296,    64,    60,   208,    72,   127,
      73,   154,    74,   167,   168,   169,   170,   171,   172,   173,
     297,   250,    66,   178,   209,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   198,   200,     4,   160,   316,   157,     4,
     219,    67,   203,   318,   319,   205,   279,   280,     4,     4,
     228,     4,   214,   261,   229,    68,    73,   262,   134,   327,
      81,    82,    58,   174,   175,   154,   233,    80,   234,     9,
      10,   122,   124,   115,    57,   131,   132,   135,   238,    11,
      12,    11,   142,    57,    57,    58,    57,    58,   277,   241,
     243,    17,    14,    15,    16,   232,   112,   113,   114,   115,
     208,   208,   256,    25,    73,    26,     4,   155,   158,   161,
      76,    77,   247,   255,     4,   162,   163,   209,   209,   251,
     209,   166,   118,   271,   156,   273,   274,   281,   218,   222,
     238,   224,    58,   272,    58,    58,   223,   275,   276,   258,
     278,    57,    58,   154,   154,   -27,   -27,   225,   227,    57,
     231,   239,   254,   293,   244,   294,   245,   285,   208,   260,
     270,   287,   282,   283,   289,   301,   208,   300,   290,   291,
     144,   302,   315,   317,   328,   209,   304,   307,   308,   322,
     126,   238,   329,   209,    78,    59,   235,    58,    58,   143,
      72,    62,    73,   217,    74,   165,   324,   320,   201,   309,
       0,   311,     0,     0,     0,     0,     0,     0,   238,   321,
       0,     0,     4,     0,   238,   238,     0,     0,     0,     0,
       0,     0,     5,     6,     0,   325,     0,     0,     0,   326,
     238,     0,     0,     0,   331,     0,     0,     0,     0,     7,
       0,     8,     0,     0,     0,   332,     9,    10,   334,     0,
       0,     0,     0,     0,    11,     0,   125,    12,     0,     0,
       0,     0,     0,    13,     0,    14,    15,    16,    17,    18,
       0,    19,    20,    21,    22,    23,    24,     4,     0,     0,
      25,     0,    26,    27,    28,     0,     0,     5,     6,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     7,     0,     8,     0,     0,     0,
       0,     9,    10,     0,     0,     0,     0,     0,     0,    11,
       0,     0,    12,     0,     0,     0,     0,     0,    13,     0,
      14,    15,    16,    17,    18,     0,    19,    20,    21,    22,
      23,    24,     4,     0,     0,    25,     0,    26,    27,    28,
       0,     0,     5,     6,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     7,
       0,     8,     0,     0,     0,     0,     9,    10,     0,     0,
       4,     0,     0,     0,    11,     0,     0,    12,     0,     0,
       5,     6,     0,    13,     0,     0,     0,     0,    17,    18,
       0,    19,    20,    21,    22,    23,    24,     7,   148,     8,
      25,     0,    26,     0,     9,    10,     0,     0,     5,     6,
       0,     0,   215,     0,   264,    12,     0,     0,   265,     0,
       0,     0,   266,     0,   148,     7,    17,     8,     0,     0,
       0,     0,     9,    10,     5,     6,     0,     0,    25,     0,
      26,     0,     0,    12,   149,     0,     0,     0,     0,     0,
     150,     7,     4,     8,    17,     0,     0,     0,     9,    10,
       0,     4,     5,     6,     0,     0,    25,     0,    26,    12,
     164,     5,     6,     0,     0,     0,   150,     0,     0,     7,
      17,     8,     0,     0,     0,     0,     9,    10,     7,     4,
       8,     0,    25,     0,    26,     9,    10,    12,     0,     5,
       6,     0,     0,    69,     0,   197,    12,     0,    17,     0,
       0,   156,     0,     0,     0,     4,     7,    17,     8,     0,
      25,     0,    26,     9,    10,     5,     6,     0,     0,    25,
       0,    26,   199,     0,    12,     0,     0,     0,     0,     0,
       0,     0,     7,     4,     8,    17,     0,     0,     0,     9,
      10,     0,     4,     5,     6,     0,     0,    25,   242,    26,
      12,     0,     5,     6,     0,     0,     0,     0,     0,     0,
       7,    17,     8,     0,     0,     0,     0,     9,    10,     7,
       4,     8,     0,    25,     0,    26,     9,    10,    12,     0,
       5,     6,     0,     0,   215,     0,     0,    12,     0,    17,
       0,     0,     0,     0,     0,     0,   148,     7,    17,     8,
       0,    25,     0,    26,     9,    10,     5,     6,     0,     0,
      25,     0,    26,     0,     0,    12,     0,     0,     0,     0,
       0,     0,     0,     7,     0,     8,    17,     0,     0,     0,
       9,    10,     0,     0,     0,     0,     0,     0,    25,     0,
      26,    12,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    17,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,    25,     0,    26,     0,     0,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,     0,     0,     0,   116,   117,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,     0,   147,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,     0,     0,     0,     0,     0,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,     0,     0,     0,   116,   117,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,     0,   306,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,     0,     0,     0,     0,     0,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,     0,     0,     0,   116,   117,
       0,     0,     0,   118,     0,     0,     0,     0,     0,     0,
       0,   230,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,     0,     0,     0,     0,     0,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,     0,     0,     0,   116,   117,     0,
       0,     0,   118,     0,     0,     0,     0,     0,     0,     0,
     240,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,     0,     0,     0,     0,     0,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,     0,     0,     0,   116,   117,     0,     0,
       0,   118,     0,     0,     0,     0,     0,     0,     0,   263,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,     0,     0,     0,     0,     0,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,     0,     0,     0,   116,   117,     0,     0,     0,
     118,     0,     0,     0,     0,     0,     0,     0,   303,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
       0,     0,     0,     0,     0,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,     0,     0,     0,   116,   117,     0,     0,     0,   118,
       0,     0,     0,   129,     0,   130,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,     0,     0,     0,
       0,     0,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,     0,     0,
       0,   116,   117,     0,     0,     0,   118,     0,   248,     0,
       0,     0,   249,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,     0,     0,     0,     0,     0,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,     0,     0,     0,   116,   117,
       0,     0,     0,   118,     0,     0,     0,   252,     0,   253,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,     0,     0,     0,     0,     0,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,     0,     0,     0,   116,   117,     0,     0,     0,
     118,     0,     0,     0,   313,     0,   314,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,     0,     0,
       0,     0,     0,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,     0,
       0,     0,   116,   117,     0,     0,     0,   118,     0,     0,
       0,     0,     0,   330,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,     0,     0,     0,     0,     0,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,     0,     0,     0,   116,
     117,     0,     0,     0,   118,     0,     0,     0,     0,     0,
     333,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,     0,     0,     0,     0,     0,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,     0,     0,     0,   116,   117,     0,     0,
       0,   118,     0,     0,     0,   220,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,     0,     0,     0,
       0,     0,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,     0,     0,
       0,   116,   117,     0,     0,     0,   118,     0,     0,     0,
     221,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,     0,     0,     0,     0,     0,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,     0,     0,     0,   116,   117,     0,     0,
       0,   118,     0,     0,     0,   305,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,     0,     0,     0,
       0,     0,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,     0,     0,
       0,   116,   117,     0,     0,     0,   118,     0,     0,     0,
     335,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,     0,     0,     0,     0,     0,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,     0,     0,     0,   116,   117,     0,     0,
       0,   118,     0,   288,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,     0,     0,     0,     0,     0,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,     0,     0,     0,   116,
     117,     0,     0,     0,   118,     0,   312,    89,    90,    91,
      92,    93,    94,     0,    96,    97,    98,    99,     0,     0,
       0,     0,     0,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,     0,
       0,     0,   116,   117,     0,     0,     0,   118,   284,    89,
      90,    91,    92,    93,    94,     0,    96,    97,    98,    99,
       0,     0,     0,     0,     0,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,     0,     0,     0,   116,   117,     0,     0,     0,   118,
     286,    89,    90,    91,    92,    93,    94,     0,    96,    97,
      98,    99,     0,     0,     0,     0,     0,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,     0,     0,     0,   116,   117,     0,     0,
       0,   118,   310,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,     0,     0,     0,     0,     0,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,     0,     0,     0,   116,   117,
     246,     0,     0,   118,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,     0,     0,     0,     0,     0,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,     0,     0,     0,   116,
     117,     0,     0,     0,   118,    89,    90,    91,    92,    93,
      94,     0,    96,    97,    98,    99,     0,     0,     0,     0,
       0,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,     0,     0,     0,
     116,   117,     0,     0,     0,   118,    95,    96,    97,    98,
      99,     0,     0,     0,     0,     0,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,     0,     0,     0,   116,     0,     0,     0,     0,
     118,    95,    96,    97,    98,    99,     0,     0,     0,     0,
       0,     0,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,    95,    96,    97,
      98,    99,     0,     0,     0,   118,     0,     0,     0,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,    95,    96,    97,    98,    99,     0,     0,
       0,   118,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,    95,
      96,    97,    98,    99,     0,     0,     0,   118,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   108,   109,   110,
     111,   112,   113,   114,   115,    95,    96,    97,    98,    99,
       0,     0,     0,   118,     0,     0,     0,     0,     0,    95,
      96,    97,    98,    99,   109,   110,   111,   112,   113,   114,
     115,     0,     0,     0,     0,     0,     0,     0,   109,   118,
     111,   112,   113,   114,   115,     0,     0,     0,     0,     0,
       0,     0,     0,   118
};

static const short int yycheck[] =
{
       5,     6,     7,     8,     9,    20,    31,    12,     2,    47,
      66,   121,     2,    50,     3,   210,     3,    55,    12,    24,
     208,    26,    16,    17,    48,     3,    16,    45,    52,    49,
      48,    56,    52,    52,    52,     0,    48,    31,    50,   215,
      52,    31,    48,    62,    50,     3,    52,    48,   150,    38,
      30,    38,    32,    33,    34,    35,    36,    51,    63,    64,
      38,    51,    81,   258,    48,    45,    48,    72,    52,    74,
      52,    49,    66,   261,   262,    48,    66,    55,    48,    49,
      50,    86,    52,    88,    89,    90,    91,    92,    93,    94,
     266,   201,    48,    98,    72,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,     3,   135,   293,   123,     3,
     139,    54,   127,   299,   300,   130,   228,   229,     3,     3,
      51,     3,   137,    51,    55,    54,    50,    55,    52,   315,
       3,     4,   136,    16,    17,   150,   159,    54,   161,    37,
      38,    54,     3,    36,    38,    54,    54,     3,   163,    45,
      48,    45,    62,    38,    38,   159,    38,   161,   224,   174,
     175,    59,    56,    57,    58,    49,    33,    34,    35,    36,
      55,    55,   207,    71,    50,    73,     3,     3,    52,    48,
      74,    75,   197,   206,     3,    51,    41,    72,    72,   204,
      72,     3,    45,   216,    53,   220,   221,   232,    52,    48,
     215,    51,   206,   218,   208,   209,    54,   222,   223,   209,
     225,    38,   216,   228,   229,     3,     4,    41,    49,    38,
      53,    49,    49,    41,    11,   260,    11,   242,    55,    49,
      49,   246,    49,    49,   249,   270,    55,    51,   253,    49,
     306,    49,    41,    47,    47,    72,    61,   282,   283,    54,
      51,   266,    49,    72,    31,    16,   162,   261,   262,    66,
      48,    17,    50,   138,    52,    86,   306,   302,   120,   284,
      -1,   286,    -1,    -1,    -1,    -1,    -1,    -1,   293,   304,
      -1,    -1,     3,    -1,   299,   300,    -1,    -1,    -1,    -1,
      -1,    -1,    13,    14,    -1,   310,    -1,    -1,    -1,   314,
     315,    -1,    -1,    -1,   329,    -1,    -1,    -1,    -1,    30,
      -1,    32,    -1,    -1,    -1,   330,    37,    38,   333,    -1,
      -1,    -1,    -1,    -1,    45,    -1,    47,    48,    -1,    -1,
      -1,    -1,    -1,    54,    -1,    56,    57,    58,    59,    60,
      -1,    62,    63,    64,    65,    66,    67,     3,    -1,    -1,
      71,    -1,    73,    74,    75,    -1,    -1,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    -1,    32,    -1,    -1,    -1,
      -1,    37,    38,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    54,    -1,
      56,    57,    58,    59,    60,    -1,    62,    63,    64,    65,
      66,    67,     3,    -1,    -1,    71,    -1,    73,    74,    75,
      -1,    -1,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      -1,    32,    -1,    -1,    -1,    -1,    37,    38,    -1,    -1,
       3,    -1,    -1,    -1,    45,    -1,    -1,    48,    -1,    -1,
      13,    14,    -1,    54,    -1,    -1,    -1,    -1,    59,    60,
      -1,    62,    63,    64,    65,    66,    67,    30,     3,    32,
      71,    -1,    73,    -1,    37,    38,    -1,    -1,    13,    14,
      -1,    -1,    45,    -1,    47,    48,    -1,    -1,    51,    -1,
      -1,    -1,    55,    -1,     3,    30,    59,    32,    -1,    -1,
      -1,    -1,    37,    38,    13,    14,    -1,    -1,    71,    -1,
      73,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,    -1,
      55,    30,     3,    32,    59,    -1,    -1,    -1,    37,    38,
      -1,     3,    13,    14,    -1,    -1,    71,    -1,    73,    48,
      49,    13,    14,    -1,    -1,    -1,    55,    -1,    -1,    30,
      59,    32,    -1,    -1,    -1,    -1,    37,    38,    30,     3,
      32,    -1,    71,    -1,    73,    37,    38,    48,    -1,    13,
      14,    -1,    -1,    54,    -1,    19,    48,    -1,    59,    -1,
      -1,    53,    -1,    -1,    -1,     3,    30,    59,    32,    -1,
      71,    -1,    73,    37,    38,    13,    14,    -1,    -1,    71,
      -1,    73,    20,    -1,    48,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    30,     3,    32,    59,    -1,    -1,    -1,    37,
      38,    -1,     3,    13,    14,    -1,    -1,    71,    18,    73,
      48,    -1,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    59,    32,    -1,    -1,    -1,    -1,    37,    38,    30,
       3,    32,    -1,    71,    -1,    73,    37,    38,    48,    -1,
      13,    14,    -1,    -1,    45,    -1,    -1,    48,    -1,    59,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    30,    59,    32,
      -1,    71,    -1,    73,    37,    38,    13,    14,    -1,    -1,
      71,    -1,    73,    -1,    -1,    48,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    -1,    32,    59,    -1,    -1,    -1,
      37,    38,    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,
      73,    48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    59,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    71,    -1,    73,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    -1,    40,    41,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    54,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    -1,    40,    41,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    54,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    -1,    40,    41,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    53,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    -1,    40,    41,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      53,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    -1,    -1,    40,    41,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    53,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    -1,    40,    41,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    53,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    -1,    40,    41,    -1,    -1,    -1,    45,
      -1,    -1,    -1,    49,    -1,    51,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      -1,    40,    41,    -1,    -1,    -1,    45,    -1,    47,    -1,
      -1,    -1,    51,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    -1,    40,    41,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    49,    -1,    51,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    -1,    40,    41,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    49,    -1,    51,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    -1,
      -1,    -1,    40,    41,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    -1,    -1,    51,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    -1,    40,
      41,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,
      51,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    -1,    -1,    40,    41,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    49,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      -1,    40,    41,    -1,    -1,    -1,    45,    -1,    -1,    -1,
      49,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    -1,    -1,    40,    41,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    49,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      -1,    40,    41,    -1,    -1,    -1,    45,    -1,    -1,    -1,
      49,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    -1,    -1,    40,    41,    -1,    -1,
      -1,    45,    -1,    47,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    -1,    40,
      41,    -1,    -1,    -1,    45,    -1,    47,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    -1,
      -1,    -1,    40,    41,    -1,    -1,    -1,    45,    46,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    -1,    40,    41,    -1,    -1,    -1,    45,
      46,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    -1,    -1,    40,    41,    -1,    -1,
      -1,    45,    46,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    -1,    40,    41,
      42,    -1,    -1,    45,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    -1,    40,
      41,    -1,    -1,    -1,    45,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    -1,    -1,    -1,
      40,    41,    -1,    -1,    -1,    45,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      45,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    45,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,    30,    31,
      32,    33,    34,    35,    36,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    11,
      12,    13,    14,    15,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    45,
      32,    33,    34,    35,    36,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    45
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    78,    79,     0,     3,    13,    14,    30,    32,    37,
      38,    45,    48,    54,    56,    57,    58,    59,    60,    62,
      63,    64,    65,    66,    67,    71,    73,    74,    75,    81,
      82,    83,    84,    85,    86,    87,    88,    95,   102,   103,
     104,   108,   114,   115,    81,   108,   108,   108,   108,   108,
      50,    80,    81,   108,     3,    38,     3,    38,    81,    85,
      87,    81,    88,    48,    48,   114,    48,    54,    54,    54,
     108,   108,    48,    50,    52,    89,    74,    75,    84,    95,
      54,     3,     4,    91,    92,    93,    48,    50,    52,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    40,    41,    45,   109,
     110,   111,    54,    52,     3,    47,    82,    49,    89,    49,
      51,    54,    54,    95,    52,     3,    48,    52,    89,    90,
     108,   108,    62,    86,   115,   116,   118,    54,     3,    49,
      55,   105,   106,   107,   108,     3,    53,   108,    52,    48,
      89,    48,    51,    41,    49,   106,     3,   108,   108,   108,
     108,   108,   108,   108,    16,    17,   112,   113,   108,   108,
     108,   108,   108,   108,   108,   108,   108,   108,   108,   108,
     108,   108,   108,   108,   108,   108,   108,    19,   108,    20,
     108,   111,   110,   108,    49,   108,    48,    49,    55,    72,
      87,    99,   100,   101,   108,    45,    48,    96,    52,    89,
      49,    49,    48,    54,    51,    41,   105,    49,    51,    55,
      53,    53,    49,    99,    99,    92,    94,    96,   108,    49,
      53,   108,    18,   108,    11,    11,    42,   108,    47,    51,
     110,   108,    49,    51,    49,    99,    95,   101,    87,    93,
      49,    51,    55,    53,    47,    51,    55,    94,    97,    98,
      49,    99,   108,   114,   114,   108,   108,   115,   108,   105,
     105,    95,    49,    49,    46,   108,    46,   108,    47,   108,
     108,    49,    93,    41,    95,   101,   101,    94,    47,    55,
      51,    95,    49,    53,    61,    49,    54,    95,    95,   108,
      46,   108,    47,    49,    51,    41,    94,    47,    94,    94,
      95,   114,    54,   117,   118,   108,   108,    94,    47,    49,
      51,   114,   108,    51,   108,    49
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  yyvsp[0] = yylval;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 163 "camp.y"
    { absyntax::root = (yyvsp[0].fil); ;}
    break;

  case 3:
#line 167 "camp.y"
    { (yyval.fil) = new file(lexerPos()); ;}
    break;

  case 4:
#line 169 "camp.y"
    { (yyval.fil) = (yyvsp[-1].fil); (yyval.fil)->add((yyvsp[0].run)); ;}
    break;

  case 5:
#line 173 "camp.y"
    { (yyval.bs) = new blockStm(lexerPos()); ;}
    break;

  case 6:
#line 175 "camp.y"
    { (yyval.bs) = (yyvsp[-1].bs); (yyval.bs)->add((yyvsp[0].run)); ;}
    break;

  case 7:
#line 184 "camp.y"
    { (yyval.n) = new simpleName((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 8:
#line 185 "camp.y"
    { (yyval.n) = new qualifiedName((yyvsp[-1].pos), (yyvsp[-2].n), (yyvsp[0].ps).sym); ;}
    break;

  case 9:
#line 186 "camp.y"
    { (yyval.n) = new qualifiedName((yyvsp[-1].pos), new simpleName((yyvsp[-1].pos), (yyvsp[-2].ps).sym),
					    (yyvsp[0].ps).sym); ;}
    break;

  case 10:
#line 196 "camp.y"
    { (yyval.run) = (yyvsp[0].d); ;}
    break;

  case 11:
#line 197 "camp.y"
    { (yyval.run) = (yyvsp[0].s); ;}
    break;

  case 12:
#line 199 "camp.y"
    { (yyval.run) = new modifiedRunnable((yyvsp[-1].ml)->getPos(), (yyvsp[-1].ml), (yyvsp[0].d)); ;}
    break;

  case 13:
#line 201 "camp.y"
    { (yyval.run) = new modifiedRunnable((yyvsp[-1].ml)->getPos(), (yyvsp[-1].ml), (yyvsp[0].bs)); ;}
    break;

  case 14:
#line 205 "camp.y"
    { (yyval.ml) = new modifierList((yyvsp[0].mod).pos); (yyval.ml)->add((yyvsp[0].mod).val); ;}
    break;

  case 15:
#line 206 "camp.y"
    { (yyval.ml) = new modifierList((yyvsp[0].perm).pos); (yyval.ml)->add((yyvsp[0].perm).val); ;}
    break;

  case 16:
#line 208 "camp.y"
    { (yyval.ml) = (yyvsp[-1].ml); (yyval.ml)->add((yyvsp[0].mod).val); ;}
    break;

  case 17:
#line 210 "camp.y"
    { (yyval.ml) = (yyvsp[-1].ml); (yyval.ml)->add((yyvsp[0].perm).val); ;}
    break;

  case 18:
#line 214 "camp.y"
    { (yyval.d) = (yyvsp[0].vd); ;}
    break;

  case 19:
#line 215 "camp.y"
    { (yyval.d) = (yyvsp[0].d); ;}
    break;

  case 20:
#line 216 "camp.y"
    { (yyval.d) = (yyvsp[0].d); ;}
    break;

  case 21:
#line 217 "camp.y"
    { (yyval.d) = new importdec((yyvsp[-2].pos), (yyvsp[-1].ps).sym); ;}
    break;

  case 22:
#line 218 "camp.y"
    { (yyval.d) = new importdec((yyvsp[-2].pos), (yyvsp[-1].ps).sym); ;}
    break;

  case 23:
#line 222 "camp.y"
    { (yyval.vd) = (yyvsp[-1].vd); ;}
    break;

  case 24:
#line 226 "camp.y"
    { (yyval.vd) = new vardec((yyvsp[-1].t)->getPos(), (yyvsp[-1].t), (yyvsp[0].dil)); ;}
    break;

  case 25:
#line 230 "camp.y"
    { (yyval.t) = (yyvsp[0].t); ;}
    break;

  case 26:
#line 235 "camp.y"
    { (yyval.t) = new arrayTy((yyvsp[-1].n), (yyvsp[0].dim)); ;}
    break;

  case 27:
#line 239 "camp.y"
    { (yyval.t) = new nameTy((yyvsp[0].n)); ;}
    break;

  case 28:
#line 245 "camp.y"
    { (yyval.dim) = new dimensions((yyvsp[-1].pos)); ;}
    break;

  case 29:
#line 246 "camp.y"
    { (yyval.dim) = (yyvsp[-2].dim); (yyval.dim)->increase(); ;}
    break;

  case 30:
#line 250 "camp.y"
    { (yyval.elist) = new explist((yyvsp[-2].pos)); (yyval.elist)->add((yyvsp[-1].e)); ;}
    break;

  case 31:
#line 252 "camp.y"
    { (yyval.elist) = (yyvsp[-3].elist); (yyval.elist)->add((yyvsp[-1].e)); ;}
    break;

  case 32:
#line 256 "camp.y"
    { (yyval.dil) = new decidlist((yyvsp[0].di)->getPos()); (yyval.dil)->add((yyvsp[0].di)); ;}
    break;

  case 33:
#line 258 "camp.y"
    { (yyval.dil) = (yyvsp[-2].dil); (yyval.dil)->add((yyvsp[0].di)); ;}
    break;

  case 34:
#line 262 "camp.y"
    { (yyval.di) = new decid((yyvsp[0].dis)->getPos(), (yyvsp[0].dis)); ;}
    break;

  case 35:
#line 264 "camp.y"
    { (yyval.di) = new decid((yyvsp[-2].dis)->getPos(), (yyvsp[-2].dis), (yyvsp[0].vi)); ;}
    break;

  case 36:
#line 268 "camp.y"
    { (yyval.dis) = new decidstart((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 37:
#line 269 "camp.y"
    { (yyval.dis) = new decidstart((yyvsp[-1].ps).pos, (yyvsp[-1].ps).sym, (yyvsp[0].dim)); ;}
    break;

  case 38:
#line 270 "camp.y"
    { (yyval.dis) = new fundecidstart((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym, 0,
                                            new formals((yyvsp[-1].pos))); ;}
    break;

  case 39:
#line 273 "camp.y"
    { (yyval.dis) = new fundecidstart((yyvsp[-3].ps).pos, (yyvsp[-3].ps).sym, 0, (yyvsp[-1].fls)); ;}
    break;

  case 40:
#line 277 "camp.y"
    { (yyval.vi) = (yyvsp[0].e); ;}
    break;

  case 41:
#line 278 "camp.y"
    { (yyval.vi) = (yyvsp[0].ai); ;}
    break;

  case 42:
#line 283 "camp.y"
    { (yyval.bs) = (yyvsp[-1].bs); ;}
    break;

  case 43:
#line 287 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[-1].pos)); ;}
    break;

  case 44:
#line 289 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[-3].pos)); (yyval.ai)->addRest((yyvsp[-1].vi)); ;}
    break;

  case 45:
#line 291 "camp.y"
    { (yyval.ai) = (yyvsp[-1].ai); ;}
    break;

  case 46:
#line 293 "camp.y"
    { (yyval.ai) = (yyvsp[-3].ai); (yyval.ai)->addRest((yyvsp[-1].vi)); ;}
    break;

  case 47:
#line 297 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[0].pos)); ;}
    break;

  case 48:
#line 298 "camp.y"
    { (yyval.ai) = (yyvsp[0].ai); ;}
    break;

  case 49:
#line 299 "camp.y"
    { (yyval.ai) = (yyvsp[-1].ai); ;}
    break;

  case 50:
#line 303 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[0].vi)->getPos());
		     (yyval.ai)->add((yyvsp[0].vi));;}
    break;

  case 51:
#line 306 "camp.y"
    { (yyval.ai) = (yyvsp[-2].ai); (yyval.ai)->add((yyvsp[0].vi)); ;}
    break;

  case 52:
#line 310 "camp.y"
    { (yyval.fls) = (yyvsp[0].fls); ;}
    break;

  case 53:
#line 312 "camp.y"
    { (yyval.fls) = (yyvsp[-2].fls); (yyval.fls)->addRest((yyvsp[0].fl)); ;}
    break;

  case 54:
#line 313 "camp.y"
    { (yyval.fls) = new formals((yyvsp[-1].pos)); (yyval.fls)->addRest((yyvsp[0].fl)); ;}
    break;

  case 55:
#line 317 "camp.y"
    { (yyval.fls) = new formals((yyvsp[0].fl)->getPos()); (yyval.fls)->add((yyvsp[0].fl)); ;}
    break;

  case 56:
#line 319 "camp.y"
    { (yyval.fls) = (yyvsp[-2].fls); (yyval.fls)->add((yyvsp[0].fl)); ;}
    break;

  case 57:
#line 323 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].t)->getPos(), (yyvsp[0].t)); ;}
    break;

  case 58:
#line 324 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].dis)->getPos(), (yyvsp[-1].t), (yyvsp[0].dis)); ;}
    break;

  case 59:
#line 326 "camp.y"
    { (yyval.fl) = new formal((yyvsp[-2].dis)->getPos(), (yyvsp[-3].t), (yyvsp[-2].dis), (yyvsp[0].vi)); ;}
    break;

  case 60:
#line 328 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].t)->getPos(), (yyvsp[0].t), 0, 0, true); ;}
    break;

  case 61:
#line 330 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].dis)->getPos(), (yyvsp[-1].t), (yyvsp[0].dis), 0, true); ;}
    break;

  case 62:
#line 332 "camp.y"
    { (yyval.fl) = new formal((yyvsp[-2].dis)->getPos(), (yyvsp[-3].t), (yyvsp[-2].dis), (yyvsp[0].vi), true); ;}
    break;

  case 63:
#line 337 "camp.y"
    { (yyval.d) = new fundec((yyvsp[-2].pos), (yyvsp[-4].t), (yyvsp[-3].ps).sym, new formals((yyvsp[-2].pos)), (yyvsp[0].bs)); ;}
    break;

  case 64:
#line 339 "camp.y"
    { (yyval.d) = new fundec((yyvsp[-3].pos), (yyvsp[-5].t), (yyvsp[-4].ps).sym, (yyvsp[-2].fls), (yyvsp[0].bs)); ;}
    break;

  case 65:
#line 341 "camp.y"
    { (yyval.d) = new fundec((yyvsp[-3].pos), (yyvsp[-5].t), (yyvsp[-4].ps).sym, (yyvsp[-2].fls), (yyvsp[0].bs)); ;}
    break;

  case 66:
#line 345 "camp.y"
    { (yyval.d) = new recorddec((yyvsp[-2].pos), (yyvsp[-1].ps).sym, (yyvsp[0].bs)); ;}
    break;

  case 67:
#line 346 "camp.y"
    { (yyval.d) = new typedec((yyvsp[-1].pos), (yyvsp[0].vd)); ;}
    break;

  case 68:
#line 351 "camp.y"
    { (yyval.e) = new fieldExp((yyvsp[-1].pos), (yyvsp[-2].e), (yyvsp[0].ps).sym); ;}
    break;

  case 69:
#line 352 "camp.y"
    { (yyval.e) = new subscriptExp((yyvsp[-2].pos),
                              new nameExp((yyvsp[-3].n)->getPos(), (yyvsp[-3].n)), (yyvsp[-1].e)); ;}
    break;

  case 70:
#line 354 "camp.y"
    { (yyval.e) = new subscriptExp((yyvsp[-2].pos), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 71:
#line 355 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-1].pos),
                                      new nameExp((yyvsp[-2].n)->getPos(), (yyvsp[-2].n)),
                                      new arglist()); ;}
    break;

  case 72:
#line 359 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-2].pos), 
                                      new nameExp((yyvsp[-3].n)->getPos(), (yyvsp[-3].n)),
                                      (yyvsp[-1].alist)); ;}
    break;

  case 73:
#line 362 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-1].pos), (yyvsp[-2].e), new arglist()); ;}
    break;

  case 74:
#line 364 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-2].pos), (yyvsp[-3].e), (yyvsp[-1].alist)); ;}
    break;

  case 75:
#line 367 "camp.y"
    { (yyval.e) = (yyvsp[-1].e); ;}
    break;

  case 76:
#line 368 "camp.y"
    { (yyval.e) = new thisExp((yyvsp[0].pos)); ;}
    break;

  case 77:
#line 372 "camp.y"
    { (yyval.arg).name=0;      (yyval.arg).val=(yyvsp[0].e); ;}
    break;

  case 78:
#line 373 "camp.y"
    { (yyval.arg).name=(yyvsp[-2].ps).sym; (yyval.arg).val=(yyvsp[0].e); ;}
    break;

  case 79:
#line 377 "camp.y"
    { (yyval.alist) = (yyvsp[0].alist); ;}
    break;

  case 80:
#line 379 "camp.y"
    { (yyval.alist) = (yyvsp[-2].alist); (yyval.alist)->rest = (yyvsp[0].arg); ;}
    break;

  case 81:
#line 380 "camp.y"
    { (yyval.alist) = new arglist(); (yyval.alist)->rest = (yyvsp[0].arg); ;}
    break;

  case 82:
#line 384 "camp.y"
    { (yyval.alist) = new arglist(); (yyval.alist)->add((yyvsp[0].arg)); ;}
    break;

  case 83:
#line 386 "camp.y"
    { (yyval.alist) = (yyvsp[-2].alist); (yyval.alist)->add((yyvsp[0].arg)); ;}
    break;

  case 84:
#line 398 "camp.y"
    { (yyval.e) = new nameExp((yyvsp[0].n)->getPos(), (yyvsp[0].n)); ;}
    break;

  case 85:
#line 399 "camp.y"
    { (yyval.e) = (yyvsp[0].e); ;}
    break;

  case 86:
#line 400 "camp.y"
    { (yyval.e) = (yyvsp[0].e); ;}
    break;

  case 87:
#line 401 "camp.y"
    { (yyval.e) = new stringExp((yyvsp[0].ps).pos, *(yyvsp[0].ps).sym); ;}
    break;

  case 88:
#line 403 "camp.y"
    { (yyval.e) = new scaleExp((yyvsp[-1].e)->getPos(), (yyvsp[-1].e), (yyvsp[0].e)); ;}
    break;

  case 89:
#line 408 "camp.y"
    { (yyval.e) = new castExp((yyvsp[-2].n)->getPos(), new nameTy((yyvsp[-2].n)), (yyvsp[0].e)); ;}
    break;

  case 90:
#line 412 "camp.y"
    { (yyval.e) = new castExp((yyvsp[-3].n)->getPos(), new arrayTy((yyvsp[-3].n), (yyvsp[-2].dim)), (yyvsp[0].e)); ;}
    break;

  case 91:
#line 414 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 92:
#line 416 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 93:
#line 417 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 94:
#line 418 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 95:
#line 419 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 96:
#line 420 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 97:
#line 421 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 98:
#line 422 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 99:
#line 423 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 100:
#line 424 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 101:
#line 425 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 102:
#line 426 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 103:
#line 427 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 104:
#line 428 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 105:
#line 429 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 106:
#line 430 "camp.y"
    { (yyval.e) = new andExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 107:
#line 431 "camp.y"
    { (yyval.e) = new orExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 108:
#line 432 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 109:
#line 433 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 110:
#line 434 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 111:
#line 436 "camp.y"
    { (yyval.e) = new newRecordExp((yyvsp[-1].pos), (yyvsp[0].t)); ;}
    break;

  case 112:
#line 442 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-2].pos), (yyvsp[-1].t), (yyvsp[0].elist), 0, 0); ;}
    break;

  case 113:
#line 444 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-3].pos), (yyvsp[-2].t), (yyvsp[-1].elist), (yyvsp[0].dim), 0); ;}
    break;

  case 114:
#line 446 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-2].pos), (yyvsp[-1].t), 0, (yyvsp[0].dim), 0); ;}
    break;

  case 115:
#line 448 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-3].pos), (yyvsp[-2].t), 0, (yyvsp[-1].dim), (yyvsp[0].ai)); ;}
    break;

  case 116:
#line 450 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-4].pos), (yyvsp[-3].t), new formals((yyvsp[-2].pos)), (yyvsp[0].bs)); ;}
    break;

  case 117:
#line 452 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-5].pos),
                                             new arrayTy((yyvsp[-4].t)->getPos(), (yyvsp[-4].t), (yyvsp[-3].dim)),
                                             new formals((yyvsp[-2].pos)),
                                             (yyvsp[0].bs)); ;}
    break;

  case 118:
#line 457 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-5].pos), (yyvsp[-4].t), (yyvsp[-2].fls), (yyvsp[0].bs)); ;}
    break;

  case 119:
#line 459 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-6].pos),
                                             new arrayTy((yyvsp[-5].t)->getPos(), (yyvsp[-5].t), (yyvsp[-4].dim)),
                                             (yyvsp[-2].fls),
                                             (yyvsp[0].bs)); ;}
    break;

  case 120:
#line 464 "camp.y"
    { (yyval.e) = new conditionalExp((yyvsp[-3].pos), (yyvsp[-4].e), (yyvsp[-2].e), (yyvsp[0].e)); ;}
    break;

  case 121:
#line 465 "camp.y"
    { (yyval.e) = new assignExp((yyvsp[-1].pos), (yyvsp[-2].e), (yyvsp[0].e)); ;}
    break;

  case 122:
#line 468 "camp.y"
    { (yyval.e) = new pairExp((yyvsp[-4].pos), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 123:
#line 470 "camp.y"
    { (yyval.e) = new tripleExp((yyvsp[-6].pos), (yyvsp[-5].e), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 124:
#line 472 "camp.y"
    { (yyval.e) = new transformExp((yyvsp[-12].pos), (yyvsp[-11].e), (yyvsp[-9].e), (yyvsp[-7].e), (yyvsp[-5].e), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 125:
#line 474 "camp.y"
    { (yyvsp[-1].j)->pushFront((yyvsp[-2].e)); (yyvsp[-1].j)->pushBack((yyvsp[0].e)); (yyval.e) = (yyvsp[-1].j); ;}
    break;

  case 126:
#line 476 "camp.y"
    { (yyvsp[-1].j)->pushFront((yyvsp[-2].e));
                     (yyvsp[-1].j)->pushBack(new nullaryExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym));
                     (yyval.e) = (yyvsp[-1].j) ;}
    break;

  case 127:
#line 480 "camp.y"
    { (yyvsp[0].se)->setSide(camp::OUT);
                     joinExp *jexp =
                         new joinExp((yyvsp[0].se)->getPos(), symbol::trans(".."));
                     (yyval.e)=jexp;
                     jexp->pushBack((yyvsp[-1].e)); jexp->pushBack((yyvsp[0].se)); ;}
    break;

  case 128:
#line 486 "camp.y"
    { (yyval.e) = new prefixExp((yyvsp[-1].ps).pos, (yyvsp[0].e), symbol::trans("+")); ;}
    break;

  case 129:
#line 488 "camp.y"
    { (yyval.e) = new prefixExp((yyvsp[-1].ps).pos, (yyvsp[0].e), symbol::trans("-")); ;}
    break;

  case 130:
#line 491 "camp.y"
    { (yyval.e) = new postfixExp((yyvsp[0].ps).pos, (yyvsp[-1].e), symbol::trans("+")); ;}
    break;

  case 131:
#line 492 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 132:
#line 494 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 133:
#line 495 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 134:
#line 496 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 135:
#line 497 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 136:
#line 499 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 137:
#line 505 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos,(yyvsp[0].ps).sym); ;}
    break;

  case 138:
#line 507 "camp.y"
    { (yyval.j) = (yyvsp[0].j); ;}
    break;

  case 139:
#line 509 "camp.y"
    { (yyvsp[-1].se)->setSide(camp::OUT);
                     (yyval.j) = (yyvsp[0].j); (yyval.j)->pushFront((yyvsp[-1].se)); ;}
    break;

  case 140:
#line 512 "camp.y"
    { (yyvsp[0].se)->setSide(camp::IN);
                     (yyval.j) = (yyvsp[-1].j); (yyval.j)->pushBack((yyvsp[0].se)); ;}
    break;

  case 141:
#line 515 "camp.y"
    { (yyvsp[-2].se)->setSide(camp::OUT); (yyvsp[0].se)->setSide(camp::IN);
                     (yyval.j) = (yyvsp[-1].j); (yyval.j)->pushFront((yyvsp[-2].se)); (yyval.j)->pushBack((yyvsp[0].se)); ;}
    break;

  case 142:
#line 520 "camp.y"
    { (yyval.se) = new specExp((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym, (yyvsp[-1].e)); ;}
    break;

  case 143:
#line 521 "camp.y"
    { (yyval.se) = new specExp((yyvsp[-2].pos), symbol::opTrans("spec"), (yyvsp[-1].e)); ;}
    break;

  case 144:
#line 523 "camp.y"
    { (yyval.se) = new specExp((yyvsp[-4].pos), symbol::opTrans("spec"),
                                          new pairExp((yyvsp[-2].pos), (yyvsp[-3].e), (yyvsp[-1].e))); ;}
    break;

  case 145:
#line 528 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 146:
#line 530 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym); (yyval.j)->pushBack((yyvsp[-1].e)); ;}
    break;

  case 147:
#line 532 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym); (yyval.j)->pushBack((yyvsp[-1].e)); ;}
    break;

  case 148:
#line 533 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 149:
#line 534 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 150:
#line 538 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym,
                              new booleanExp((yyvsp[-1].ps).pos, false)); ;}
    break;

  case 151:
#line 541 "camp.y"
    { (yyval.e) = new ternaryExp((yyvsp[-3].ps).pos, (yyvsp[-2].e), (yyvsp[-3].ps).sym, (yyvsp[0].e),
                              new booleanExp((yyvsp[-3].ps).pos, false)); ;}
    break;

  case 152:
#line 544 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-2].ps).pos, (yyvsp[0].e), (yyvsp[-2].ps).sym,
                              new booleanExp((yyvsp[-1].ps).pos, true)); ;}
    break;

  case 153:
#line 547 "camp.y"
    { (yyval.e) = new ternaryExp((yyvsp[-4].ps).pos, (yyvsp[-2].e), (yyvsp[-4].ps).sym, (yyvsp[0].e),
                              new booleanExp((yyvsp[-3].ps).pos, true)); ;}
    break;

  case 154:
#line 552 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 155:
#line 554 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-3].ps).pos, (yyvsp[-2].e), (yyvsp[-3].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 156:
#line 558 "camp.y"
    { (yyval.s) = new emptyStm((yyvsp[0].pos)); ;}
    break;

  case 157:
#line 559 "camp.y"
    { (yyval.s) = (yyvsp[0].bs); ;}
    break;

  case 158:
#line 560 "camp.y"
    { (yyval.s) = (yyvsp[-1].s); ;}
    break;

  case 159:
#line 562 "camp.y"
    { (yyval.s) = new ifStm((yyvsp[-4].pos), (yyvsp[-2].e), (yyvsp[0].s)); ;}
    break;

  case 160:
#line 564 "camp.y"
    { (yyval.s) = new ifStm((yyvsp[-6].pos), (yyvsp[-4].e), (yyvsp[-2].s), (yyvsp[0].s)); ;}
    break;

  case 161:
#line 566 "camp.y"
    { (yyval.s) = new whileStm((yyvsp[-4].pos), (yyvsp[-2].e), (yyvsp[0].s)); ;}
    break;

  case 162:
#line 568 "camp.y"
    { (yyval.s) = new doStm((yyvsp[-6].pos), (yyvsp[-5].s), (yyvsp[-2].e)); ;}
    break;

  case 163:
#line 570 "camp.y"
    { (yyval.s) = new forStm((yyvsp[-8].pos), (yyvsp[-6].run), (yyvsp[-4].e), (yyvsp[-2].sel), (yyvsp[0].s)); ;}
    break;

  case 164:
#line 571 "camp.y"
    { (yyval.s) = new breakStm((yyvsp[-1].pos)); ;}
    break;

  case 165:
#line 572 "camp.y"
    { (yyval.s) = new continueStm((yyvsp[-1].pos)); ;}
    break;

  case 166:
#line 573 "camp.y"
    { (yyval.s) = new returnStm((yyvsp[-1].pos)); ;}
    break;

  case 167:
#line 574 "camp.y"
    { (yyval.s) = new returnStm((yyvsp[-2].pos), (yyvsp[-1].e)); ;}
    break;

  case 168:
#line 578 "camp.y"
    { (yyval.s) = new expStm((yyvsp[0].e)->getPos(), (yyvsp[0].e)); ;}
    break;

  case 169:
#line 582 "camp.y"
    { (yyval.run) = 0; ;}
    break;

  case 170:
#line 583 "camp.y"
    { (yyval.run) = (yyvsp[0].sel); ;}
    break;

  case 171:
#line 584 "camp.y"
    { (yyval.run) = (yyvsp[0].vd); ;}
    break;

  case 172:
#line 588 "camp.y"
    { (yyval.sel) = 0; ;}
    break;

  case 173:
#line 589 "camp.y"
    { (yyval.sel) = (yyvsp[0].sel); ;}
    break;

  case 174:
#line 593 "camp.y"
    { (yyval.sel) = new stmExpList((yyvsp[0].s)->getPos()); (yyval.sel)->add((yyvsp[0].s)); ;}
    break;

  case 175:
#line 595 "camp.y"
    { (yyval.sel) = (yyvsp[-2].sel); (yyval.sel)->add((yyvsp[0].s)); ;}
    break;


    }

/* Line 1037 of yacc.c.  */
#line 2755 "camp.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {

		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 yydestruct ("Error: popping",
                             yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yydestruct ("Error: discarding lookahead",
              yytoken, &yylval);
  yychar = YYEMPTY;
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}



